Subject: RE: [Sip] ABNF comment/nit on draft-ietf-sip-rfc2543bis-03.txt

From: "Rosen, Brian" <[email-masked]>
Date: Tue, 10 Jul 2001 10:14:33 -0400

FWIW, I'll volunteer to do this if we think it's really worth it.
Proofing it will take more work than editing, for sure.
I'd rather edit than proof :)

Brian
ABNF hacker extradinaire

> -----Original Message-----
> From: Jonathan Lennox [mailto:[email-masked]]
> Sent: Tuesday, July 10, 2001 10:08 AM
> To: Henning G. Schulzrinne
> Cc: Chip Sharp; [email-masked]
> Subject: Re: [Sip] ABNF comment/nit on 
> draft-ietf-sip-rfc2543bis-03.txt
> 
> 
> On Monday, July 9 2001, "Henning G. Schulzrinne" wrote to 
> "Chip Sharp, [email-masked]" saying:
> 
> > Beyond the / vs. |, the major difference is that RFC 2234 is a
> > character-oriented grammar, while SIP (and HTTP) use a word-oriented
> > grammar. We'd have to add a lot of LWSP everywhere in the grammar,
> > basically between every token, as in
> > 
> > Subject  =  ( "Subject" $|$ "s" ) ":" TEXT-UTF8-TRIM
> > 
> > becomes
> > 
> > Subject = ( "Subject" $|$ "s") LWSP ":" LWSP TEXT-UTF8-TRIM
> > 
> > and more complicated grammars become even messier. I'm not convinced
> > that this visual noise aids understanding, but there may be other
> > reasons to do this.
> 
> The main motivation for this, IMO, would be that, currently, 
> you have to do
> a fairly close reading of the spec in order to determine where LWSP is
> allowed.
> 
> For instance, consider (just as an example extracted from a 
> quick browsing
> of the spec):
> 
>         Timestamp  =  "Timestamp" ":" *(DIGIT) [ "." *(DIGIT) 
> ] [ delay ]
>         delay      =  *(DIGIT) [ "." *(DIGIT) ]
> 
> As I understand it, LWSP is *allowed* before and after the colon, is
> *required* between the timestamp and the delay, and is 
> *forbidden* before
> and after the decimal points, and between the digits.
> 
> I think this interpretation is probably derivable from the 
> implicit-lwsp
> rules (since "." is a word character but ":" isn't) but it's very
> non-obvious.
> 
> I've made some attempts at automatically generating a SIP 
> parser from the
> grammar in the spec.  The LWSP issue is by far the hardest 
> thing to resolve.
> 
> -- 
> Jonathan Lennox
> [email-masked]
> 
> _______________________________________________
> Sip mailing list  http://www.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol
> Use [email-masked] for questions on current sip
> Use [email-masked] for new developments on the application of sip
> 

_______________________________________________
Sip mailing list  http://www.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: Chip Sharp <[email-masked]>
Date: Tue, 10 Jul 2001 10:36:51 -0400

I'll volunteer to help out if there is an interest.
Of course the problem is not to break existing syntax.

Chip

>I'd rather edit than proof :)
...snip...

---

From: "Fairlie-Cuninghame, Robert" <[email-masked]>
Date: Wed, 11 Jul 2001 05:46:24 -0700

Hi Henning,

Hmmm.... you are of course correct. However I think that bis-03 is worded
rather deceptively. It explicitly says that the name is followed by a colon
and that white space MAY then be used after the colon (inferring it is not
allowed beforehand otherwise why would only one-side be mentioned?).

---
Section 10.5 Header Field Format

Header fields ("general-header", "request-header", "response-header", and
"entity-header") follow the same generic header format as that given in
Section 3.1 of RFC 822 [25]. Each header field consists of a name followed
by a colon (":") and the field value. Field names are case-insensitive. The
field value MAY be preceded by any amount of leading white space (LWS),
though a single space (SP) is preferred.
---

Robert.

> From: Henning G. Schulzrinne [mailto:[email-masked]]
> Sent: Tuesday, July 10, 2001 2:46 PM
> To: Fairlie-Cuninghame, Robert
> "Fairlie-Cuninghame, Robert" wrote:
> >
> > Well just to stir the pot a little <grin> ...... isn't LWS
> only allowed on
> > the right hand side of the colon and not on the left.
> >
>
> Anywhere between tokens.
>
> Subject : something
>
> is perfectly legal. See test1.txt of the torture tests, for example.
>
> --
> Henning Schulzrinne   http://www.cs.columbia.edu/~hgs
>